package test;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
class Keisoku {
	private static final int changes = 100;
	private static final int max=10000;
	private static final int num = 3;
	private static final String[] ave = {"for","stream"};
	private static double[] result = new double[num];
	public static void main(String[] args) {	
		switch((int) (Math.random()*3)){
		case 0: test(new kotae.TDUList<>());
		break;
		case 1: test(new LinkedList<>());
		break;
		case 2: test(new ArrayList<>());
		break;
		}
	}
	private static void test( List<Integer> list) {
		StopWatch sw = new StopWatch();	
		for(int i=0;i<max;i++){
			list.add((int) (Math.random()*1000));
		}
		System.out.println("Addition:\t"+sw);
		for(int i=0;i<changes;i++){
			list.set((int) (Math.random()*max),(int) (Math.random()*1000));
		}
		System.out.println("Set:\t"+sw);
		int method = (int)(Math.random()*2);
		System.out.println("Calculating the average by using "+ave[method]);
		for(int i=0;i<num;i++){
			switch(method){
			case 0:
				result[i]=0;
				for(Integer x : list){
					result[i]+=x;
				}
				result[i]/=max;
				break;
			case 1:
				result[i]= list.stream().mapToInt(x->x.intValue()).average().getAsDouble();
				break;
			}
			System.out.println(i+":\t"+sw);
		}
		System.out.println(Arrays.toString(result));
		System.out.println(list.getClass().getName());
	}
}
